## livestream-adresse.inc - Liste der Livestreams in den Mediatheken
## 
## Version 1.28 - 12.12.2023
## 
## ==================================================================================================================================================================
## !!! Die Sender/Mediatheken ändern manchmal die Livestream-Adressen, eine regelmäßige Kontrolle der in Mediathekview eingetragenen 
## !!! Livestream-Adressen und der in forum.mediathekview.de genannten Alternativadressen (z.B. rbb, orf1...3 usw.) ist sinnvoll.
## 
## !!! Einige Sender der ZDF-Schiene blocken zeitweise die Nutzung außerhalb von Web-Browsern, Streaming via Mediathekview, VLC, FFMPEG usw. ist dann meistens trotzdem möglich
## ==================================================================================================================================================================
## 
## ~/livestream-adresse.inc wird verwendet von livestream-aufnahme.sh, livestream-aufnahme-rm.sh und livestream-vlc.sh
## 
## .......... Die Streamadressen der Sender sind folgenden Quellen entnommen: 
## .......... 1. Mediathekview (JAVA-Anwendung für Linux, Mac und Windows) - Spalte URL in der Filmliste mit aktiviertem Schalter "Livestreams"
## .......... 2. forum.mediathekview.de
## 
## Nur für LINUX bash...
## livestream-vlc.sh: ........ Livestreams der öffentlich-rechtlichen Mediatheken in VLC ansehen
## ........................... Parameter: Sender (ard, zdf, rbb, rbb-brb, mdr, ndr, wdr,swr, hr, br, sr, neo, 3sat, arte, info, 
## ........................... .................. phoenix, alpha, one, tagesschau, kika, orf1, orf2, orf3, orf-sport, arte-fr)
## ........................... Speicherort: beliebiges Benutzerverzeichnis, verwendet livestream-adresse.inc
## filmschnitt.sh:............ Videodatei schneiden und konvertieren (möglichst nach MP4 1280x720)
## ........................... Parameter: [HDfull|HDready|DVD|Android] Videodatei [Startzeit(hh:mm:ss) [Stopzeit(hh:mm:ss) [FPSx1000 Audiooffset]]]
## ........................... Speicherort: beliebiges Benutzerverzeichnis, verwendet livestream-adresse.inc
## livestream-aufnahme.sh:.... Livestreams der öffentlich-rechtlichen Mediatheken zeitgesteuert aufnehmen/speichern
## ........................... Parameter: Sender(wie bei livestream-vlc.sh) Startzeit(YYYYMMDDhhmm) Dauer(mmm) Name
## ........................... Speicherort: Benutzer-Homeverzeichnis (~/), 
## ........................... ............ verwendet livestream-adresse.inc, livestream-aufnahme.sh, livestream-aufnahme-rm.sh
## livestream-aufnahme-pre.sh: Livestreams der öffentlich-rechtlichen Mediatheken aus TVbrowser zeitgesteuert aufnehmen/speichern
## ........................... Parameter: [remove] Sender(wie bei livestream-vlc.sh, Jahr Monat Tag Stunde Minute Dauer Name
## ........................... Speicherort: Benutzer-Homeverzeichnis (~/), verwendet livestream-adresse.inc
## livestream-aufnahme-rm.sh:. Programmierte Aufnahme löschen
## ........................... Parameter: Sender(wie bei livestream-vlc.sh) Startzeit(YYYYMMDDhhmm) Dauer(mmm) Name
## ........................... Speicherort: Benutzer-Homeverzeichnis (~/), verwendet livestream-adresse.inc
## livestream-adresse.inc:.... Senderliste für  die bash-Scripte
## ........................... Speicherort: Benutzer-Homeverzeichnis (~/)
## 
datum_zeit=$(date +%Y-%m-%d_%H-%M)
## 
# #########################################################################
# Zeichenersetzung:
function zeichenersetzen {
  read tmpstr
  tmpstr=$(echo $tmpstr | sed -e 's/\ä/ae/g;s/\å/a/g;s/\ö/oe/g;s/œ/oe/g;s/Œ/Oe/g;s/\ø/oe/g;s/\ü/ue/g;s/\Ä/Ae/g;s/\Å/A/g;s/\Ö/Oe/g;s/\Ø/Oe/g;s/\Ü/Ue/g;s/\ß/ss/g;s/Č/C/g;s/č/c/g;s/+/_und_/g;s/[-|_]Video_/_/g')
  tmpstr=$(echo $tmpstr | sed -e 's/\À/A/g;s/\Á/A/g;s/\Â/A/g;s/\Ã/A/g;s/\Æ/Ae/g;s/\Ç/C/g;s/\È/E/g;s/\É/E/g;s/\Ê/E/g;s/\Ë/E/g;s/\Ì/I/g;s/\Í/I/g;s/\Î/I/g;s/\Ï/I/g;s/\Ñ/N/g;s/\Ò/O/g;s/\Ó/O/g;s/\Ô/O/g;s/\Õ/O/g;s/\Ù/U/g;s/\Ú/U/g;s/\Û/U/g;s/\Ý/Y/g')
  tmpstr=$(echo $tmpstr | sed -e 's/\à/a/g;s/\á/a/g;s/\â/a/g;s/\ã/a/g;s/\æ/ae/g;s/\ç/c/g;s/\è/e/g;s/\é/e/g;s/\ê/e/g;s/\ë/e/g;s/\ì/i/g;s/\í/i/g;s/\î/i/g;s/\ï/i/g;s/\ñ/n/g;s/\ò/o/g;s/\ó/o/g;s/\ô/o/g;s/\õ/o/g;s/\ù/u/g;s/\ú/u/g;s/\û/u/g;s/\ý/y/g;s/\ÿ/y/g')
  printf "$tmpstr"
}
filterZeichen=1     # 1=Sonderzeichen (Umlaute usw.) in Dateinamen und Unterverzeichnissen durch Standardzeichen ersetzen


# Farbformatierung: 
SETWS="\033[0;37m" ; SETGR="\033[0;90m" ; SETSW="\033[0;30m" ; SETGE="\033[0;93m" ; SETBLD="\033[38;5;19m" ; SETBL="\033[38;5;33m" ; SETTK="\033[38;5;123m" ; SETGND="\033[38;5;28m" ; SETGN="\033[38;5;46m" ; SETORD="\033[38;5;202m" ; SETOR="\033[38;5;214m" ; SETRTD="\033[1;31m" ; SETRT="\033[38;5;196m" ; SETFL="\033[5m" ; NOCOL="\033[0m\033[25m"
SETBGSW="\033[40m" ; SETBGRT="\033[41m" ; SETBGGN="\033[42m" ; SETBGBL="\033[44m" ; SETBGGR="\033[48;5;237m" ; SETBGWS="\033[47m" ; SETBGWW="\033[48;5;15m"
SETFLOR=$SETOR$SETFL ; SETFLRT=$SETRT$SETFL ; SETUL="\033[4m"
SETBGAL=$SETBGBL ; SETBGOK=$SETBGWS
SETAL2=$SETFLRT ; SETAL1=$SETRT ; SETWA2=$SETFLOR ; SETWA1=$SETOR ; SETOK=$SETGN

function findePfad {
  if [ "$1" != "" ]; then
    retval="$1"
    [ "${retval: -1}" == '/' ] && retval="${retval:0: -1}"
    #####################################################
    # klappt noch nicht: Erkennung von Softlink im Pfad
    dnpt=""
    uppt="$retval"
    while [ ${#uppt} -gt 1 ]; do
      if [ "${#uppt}" -gt 1 ] && [ "$(readlink $uppt)" != "" ]; then
        uppt="$(readlink $uppt)"
        break
      else
        dnpt="${uppt##*/}/$dnpt"
        uppt=${uppt%/*}
      fi
    done
    if [ ${#uppt} -gt 1 ]; then retval="$uppt/$dnpt"; fi
    retval=$(echo $retval | sed -e 's/\/\//\//g;s/\/$//')
    #####################################################
    #[ "$(readlink $retval > /dev/null 2> /dev/null)" != "" ] && retval="$(readlink $retval > /dev/null 2> /dev/null)"
    [ "$retval" == "" ] && retval="$1"
  else
    retval=""
  fi
  echo "$retval"
}

## 
## Arbeitsverzeichnisse:
## aufnahmepfad_absolut ist das Basisverzeichnis für alle Aufnahmen und Hilfsverzeichnisse
homeverzeichnis=$HOME/
aufnahmepfad_absolut=${homeverzeichnis}Multimedia/DVBT-Aufnahme/
#aufnahmepfad_absolut=/_data1/Multimedia/DVBT-Aufnahme/
ablagepfat_absolut=${aufnahmepfad_absolut}0000_Mediathekview/
## scriptpfad_relativ ist das Unterverzeichnis unter aufnahmepfad_absolut, in dem die Aufzeichnungs- und Löschscripte liegen
scriptpfad_relativ=tmp/
## logpfad_relativ ist das Unterverzeichnis unter aufnahmepfad_absolut, in dem die logdateien liegen
logpfad_relativ=tmp-log/
## ================================================================================================================
## Tabelle "streamaddr" erweitert um DVBT-/Mediathek-Sendernamen und Markierung eventuell fehlerhafter Audiostreams
## Namenfilterung/Ersatz von Sonderzeichen
## ================================================================================================================
## 03.02.2022: Farbcode GR
## 02.01.2021: DVBT-Sendernamen soweit möglich an automatische Namen in Kaffeine angepasst, für5 filmschnitt.sh nuss aberin Kaffeine wdr_HD-Köln in wdr_Köln_HD geändert werden.
## 21.11.2020: Mediathek-Adressen aktualisiert: ORF 1/2/3/S, DW, 3SAT, BR, HR, PHOENIX, SR, SWR, ZDF, ZDFinfo, ZDFneo
## 08.02.2020: Anpassung an neue PC-Installation mit NAS-Nutzung: Aufnahme auf lokaler HD in Pfad "$aufnahmepfad_absolut", danach verschieben nach "$ablagepfad_absolut", falls dieses Verzeichnis existiert.
## 02.09.2019: Seit Ende August 2019 werden auf der ZDF-Schiene alle Mediathek-Streams via VLC oder FFMPEG geblockt/mit unbekannter Adresse abgebrochen! Streamen geht nur noch im Browser, dort werden aber auch "geschützte" Sendungen geblockt.
## 31.08.2019: seit 03/2019 bzw. mit ffmpeg 4.1.4 scheint aaclatm konvertierbar zu sein, darum ist für alle Sender wieder die direkte Konvertierung aktiv.
## 14.01.-28.08.2019: neben diversen Korrekturen der Konvertieroptionen mussten auch Stream-Adressen (ARD) korrigiert werden.
## 16.12.2018: Konvertiertyp 3 (alle Audiostreams einbinden) wegen Audiostream-Problem (oft bei ARD und ONE, manchmal dritten Programmen): Hauptstream nach Konvertieren
## ........... manchmal nur Geräüsche, keine Sprache
## 12.12.2018: Livestream-Adressen korrigiert: wdr, ndr, kika, 
## 01.06.2018: Livestream-Adressen korrigiert: mdr 
## 27.06.2018: Sendername korrigiert - SWR-BW-HD-dvbt2
## 08.06.2018: arte-HD-dvbt2 wieder Konvertiertyp 1 (copy TS/optional recode MP4), um Weiterverarbeitung trotz wahrscheinlichem Fehler zu ermöglichen.
## 10.06.2018: arte-HD-dvbt2 von Konvertiertyp 1 (copy TS/optional recode MP4) nach 2 (nur copy TS) geändert
## 08.07.2018: arte-HD-dvbt2 wieder Konvertiertyp 1 (copy TS/optional recode MP4)
## 10.07.2018: Sendername korrigiert: zdf-neo-HD-dvbt2
## 30.07.2018: alte DVBT-Sendernamen, auch Privatsender, für Nachbearbeitung eingetragen
## 03.08.2018: Blockade der Mediathek-Aufnahmeprogrammierung durch Erweiterung der Sendernamen für Nachbearbeitung alter Aufnahmen behoben
## 13.09.2018: Livestream-Adressen korrigiert: ard (die haben wohl schon vor einigen Tagen die URL geändert!), alte und neue orf-Adressen funktionieren nicht
## 06.11.2018: Senderliste auf https umgestellt. 
## ........... Wegen permanenter Audio-Konvertierprobleme bei ARTE nur erste Konvertierstufe. ARD-Schiene uneinheitlich, teilweise klappt zweite Stufe.
## 19.11.2018: Nach Problemen nach defektem SW-Update des Remote-PC und daraus folgendem Ausfall des Remote-Programmierzugriffs Anpassung der DVBT2-Namen zur
## ........... vereinfachten manuellen Programmierung, einige Berlin-Radiosender zugefügt
## ================================================================================================================
## Tabellenelemente:
##   Wert 1: Sender
##   Wert 2: Stream-Priorität, z.Z.nicht benutzt
##   Wert 3: (*) DVBT-Sendername
##   Wert 4: DVBT-Senderstream mit eventuell nicht konvertierendem AAC_LATM Audiostream (0=recode MP4, 1=copy TS)
##   Wert 5: (**) Mediathek-Sendername
##   Wert 6: Mediathek-Senderstream mit eventuell nicht konvertierendem AAC_LATM Audiostream (0=recode MP4, 1=copy TS)
##   Wert 7: Livestream-Adresse
## ----------------------------------------------------------------------------------------------------------------
## *)  Sendername der DVBT2-Anwendung (Übernahme dieses Strings in den Dateinamen muss in der Anwendung aktiviert sein!
## **) Sendername der Livestream Aufzeichnung (siehe Hinweise in livestream-aufnahme*.sh bzw. zu tvbrowser)
## ================================================================================================================
##           Sender  Prio DVBT                AudErr Mediathek AudErr Streamadresse 
## DVBT2/ÖR-Mediatheken
streamaddr=(ard         c _Das-Erste-HD-dvbt2    0 _ARD-HD_        0 "http://mcdn.daserste.de/daserste/de/master.m3u8")
streamaddr+=(xxxardxxx  c _Das_Erste_HD-dvbt2    0 _ARD-SD_        0 "")
streamaddr+=(zdf        d _ZDF-HD-dvbt2          0 _ZDF-HD_        0 "http://zdf-hls-15.akamaized.net/hls/live/2016498/de/high/master.m3u8")
streamaddr+=(xxxzdfxxx  d _ZDF_HD-dvbt2          0 _ZDF-SD_        0 "")
streamaddr+=(rbb        g _rbb-Brandenburg-HD-dvbt2 0 _RBB-HD_     0 "http://rbblive-lh.akamaihd.net/i/rbb_brandenburg@349369/master.m3u8")
streamaddr+=(xxxrbbxxx  g _rbb_Brandenburg_HD-dvbt2 0 _RBB-SD_        0 "")
streamaddr+=(mdr        g _MDR-Sachsen-HD-dvbt2  0 _MDR-HD_        0 "http://mdrsnhls-lh.akamaihd.net/i/livetvmdrsachsen_de@513998/master.m3u8")
streamaddr+=(xxxmdrxxx  g _MDR_Sachsen_HD-dvbt2  0 _MDR-SD_        0 "")
streamaddr+=(ndr        g _NDR-FS-NDS-HD-dvbt2   0 _NDR-HD_        0 "http://ndrfs-lh.akamaihd.net/i/ndrfs_nds@430233/master.m3u8")
streamaddr+=(xxxndrxxx  g _NDR_FS_NDS_HD-dvbt2   0 _NDR-SD_        0 "")
streamaddr+=(wdr        g _WDR-Köln-HD-dvbt2     0 _WDR-HD_        0 "http://wdrfsgeo-lh.akamaihd.net/i/wdrfs_geogeblockt@530016/master.m3u8")
streamaddr+=(xxxwdrxxx  g _WDR_Köln_HD-dvbt2     0 _WDR-SD_        0 "")
streamaddr+=(wdr_x      g _WDR-Koeln-HD-dvbt2    0 _WDR-HD_        0 "http://wdrfsgeo-lh.akamaihd.net/i/wdrfs_geogeblockt@530016/master.m3u8")
streamaddr+=(xxxwdr_xxx g _WDR_Koeln_HD-dvbt2    0 _WDR-SD_        0 "")
streamaddr+=(swr        g _SWR-BW-HD-dvbt2       0 _SWR-HD_        0 "https://swrbwhls-i.akamaihd.net/hls/live/667638/swrbwd/master.m3u8")
streamaddr+=(xxxswrxxx  g _SWR_BW_HD-dvbt2       0 _SWR-SD_        0 "")
streamaddr+=(hr         g _hr-fernsehen-HD-dvbt2 0 _HR-HD_         0 "http://hrlive1-lh.akamaihd.net/i/hr_fernsehen@75910/master.m3u8")
streamaddr+=(xxxhrxxxx  g _hr-fernsehen_HD-dvbt2 0 _HR-SD_         0 "")
streamaddr+=(br         g _BR-Fernsehen-HD-dvbt2 0 _BR-HD_         0 "http://brlive-lh.akamaihd.net/i/bfsnord_germany@119898/master.m3u8")
streamaddr+=(xxxbrxxxx  g _BR_Fernsehen_HD-dvbt2 0 _BR-SD_         0 "")
streamaddr+=(sr         g @@@@@@@@@@             0 _SR-HD_         0 "http://srlive24-lh.akamaihd.net/i/sr_universal02@107595/master.m3u8")
streamaddr+=(xxxsrxxxx  g @@@@@@@@@@             0 _SR-SD_         0 "")
streamaddr+=(neo        d _zdf-neo-HD-dvbt2      0 @@@@@@@@@@      0 "http://zdf-hls-16.akamaized.net/hls/live/2016499/de/high/master.m3u8")
streamaddr+=(xxxneoxxx  d _zdf_neo_HD-dvbt2      0 @@@@@@@@@@      0 "")
streamaddr+=(3sat       f _3sat-HD-dvbt2         0 _3Sat-HD_       0 "http://zdf-hls-18.akamaized.net/hls/live/2016501/dach/high/master.m3u8")
streamaddr+=(xxx3satxx  f _3sat_HD-dvbt2         0 _3Sat-SD_       0 "")
streamaddr+=(arte       e _arte-HD-dvbt2         0 _ARTE.DE-HD_    0 "http://artelive-lh.akamaihd.net/i/artelive_de@393591/master.m3u8")
streamaddr+=(xxxartexx  e _arte_HD-dvbt2         0 _ARTE.DE-SD_    0 "")
streamaddr+=(phoenix    h _PHOENIX-HD-dvbt2      0 _PHOENIX-HD_    0 "http://zdf-hls-19.akamaized.net/hls/live/2016502/de/high/master.m3u8")
streamaddr+=(xxxphoenix h _PHOENIX_HD-dvbt2      0 _PHOENIX-SD_    0 "")
streamaddr+=(info       h _ZDFinfo-HD-dvbt2      0 @@@@@@@@@@      0 "http://zdf-hls-17.akamaized.net/hls/live/2016500/de/high/master.m3u8")
streamaddr+=(alpha      h _ZDFinfo_HD-dvbt2      0 @@@@@@@@@@      0 "http://livestreams.br.de/i/bralpha_germany@119899/master.m3u8")
streamaddr+=(one        c _ONE-HD-dvbt2          0 _ONE_HD_        0 "http://onelivestream-lh.akamaihd.net/i/one_livestream@568814/master.m3u8")
streamaddr+=(xxxonexxx  c _ONE_HD-dvbt2          0 _ONE_SD_        0 "http://onelivestream-lh.akamaihd.net/i/one_livestream@568814/master.m3u8")
streamaddr+=(rbb-bln    g _rbb-Berlin-HD-dvbt2   0 _RBB-BLN-HD_    0 "http://rbblive-lh.akamaihd.net/i/rbb_berlin@144674/master.m3u8")
streamaddr+=(xxxrbb-bln g _rbb_Berlin_HD-dvbt2   0 _RBB-BLN-SD_    0 "")
streamaddr+=(tagesschau h _tagesschau24-HD-dvbt2 0 @@@@@@@@@@      0 "http://tagesschau-lh.akamaihd.net/i/tagesschau_1@119231/master.m3u8")
streamaddr+=(tagesschxx h _tagesschau24_HD-dvbt2 0 @@@@@@@@@@      0 "http://tagesschau-lh.akamaihd.net/i/tagesschau_1@119231/master.m3u8")
streamaddr+=(kika       d _KiKA-HD-dvbt2         0 _KiKA-HD_       0 "http://kikade-lh.akamaihd.net/i/livetvkika_de@450035/master.m3u8")
streamaddr+=(xxxkikaxx  d _KiKA_HD-dvbt2         0 _KiKA-SD_        0 "")
#streamaddr+=(dw         h @@@@@@@@@@             0 _DW-HD_         0 "http://dwstream6-lh.akamaihd.net/i/dwstream6_live@123962/master.m3u8")
#streamaddr+=(orf1       i @@@@@@@@@@             0 _ORF-HD_        0 "http://orf1.mdn.ors.at/out/u/orf1/qxb/manifest.m3u8")
#streamaddr+=(orf2       i @@@@@@@@@@             0 @@@@@@@@@@      0 "http://orf2.mdn.ors.at/out/u/orf2/qxb/manifest.m3u8")
#streamaddr+=(orf3       i @@@@@@@@@@             0 @@@@@@@@@@      0 "http://orf3.mdn.ors.at/out/u/orf3/qxb/manifest.m3u8")
#streamaddr+=(orf-sport  i @@@@@@@@@@             0 @@@@@@@@@@      0 "http://orfs.mdn.ors.at/out/u/orfs/qxb/manifest.m3u8")
#streamaddr+=(arte-fr    e @@@@@@@@@@             0 _ARTE.FR-HD_    0 "http://artelive-lh.akamaihd.net/i/artelive_fr@344805/master.m3u8")
#streamaddr+=(xxxxxxxx   z @@@@@@@@@@            -1 @@@@@@@@@@     -1 "")
## ----------------------------------------------------------------------------
#streamaddr+=(RadioBerlin88.8 z @@@@@@@@@@ -1 RadioBerlin88.8 -1 "http://www.radioberlin.de/live.m3u")
#streamaddr+=(RadioEins       z @@@@@@@@@@ -1 RadioEins       -1 "http://www.radioeins.de/live.m3u")
#streamaddr+=(Inforadio       z @@@@@@@@@@ -1 Inforadio       -1 "http://www.inforadio.de/live.m3u")
#streamaddr+=(Kulturradio     z @@@@@@@@@@ -1 Kulturradio     -1 "http://www.kulturradio.de/live.m3u")
#streamaddr+=(Fritz           z @@@@@@@@@@ -1 Fritz           -1 "http://www.fritz.de/live.m3u")
#streamaddr+=(AntenneBrb      z @@@@@@@@@@ -1 AntenneBrb      -1 "http://www.antennebrandenburg.de/live.m3u")
## ----------------------------------------------------------------------------
streamaddr+=(x99 z @@@@@@@@@@ 0 @@@@@@@@@@ 0 "")
## ================================================================================================================
streamaddrsize=7
idxSenderkuerzel=0
idxSenderprio=1
idxSendername_DVBT=2
idxAACLATM_DVBT=3
idxSendername_Mediathek=4
idxAACLATM_Mediathek=5
idxStreamaddr=6
## ================================================================================================================
function namemod {
  # Sprachspezifische Umlaute und Sonderzeichen ersetzen
  for ((z=0;z<32;z++))
  do
    xname=${xname/\ /_}
    xname=${xname/\Ä/Ae}
    xname=${xname/\ä/ae}
    xname=${xname/\Ö/Oe}
    xname=${xname/\ö/oe}
    xname=${xname/\Ü/Ue}
    xname=${xname/\ü/ue}
    xname=${xname/\ß/ss}
    xname=${xname/\Á/A}
    xname=${xname/\á/a}
    xname=${xname/\À/A}
    xname=${xname/\à/a}
    xname=${xname/\É/E}
    xname=${xname/\é/e}
    xname=${xname/\È/E}
    xname=${xname/\è/e}
    xname=${xname/\Å/A}
    xname=${xname/\å/a}
    xname=${xname/\Ø/Oe}
    xname=${xname/\ø/oe}
    #xname=${xname/\-/-}
    xname=${xname/\?/_}
    xname=${xname/\!/_}
    xname=${xname/\:/-}
    xname=${xname/\,/-}
    xname=${xname/\;/-}
    xname=${xname/\(/}
    xname=${xname/\)/}
    xname=${xname/\[/}
    xname=${xname/\]/}
    xname=${xname/\&/und}
    xname=${xname/\§/}
    xname=${xname/\#/}
    xname=${xname/\°/}
    xname=${xname/\%/}
    xname=${xname/\//von}
    xname=${xname/\{/_}
    xname=${xname/\}/_}
    xname=${xname/\'/}
    xname=${xname/\"/}
    xname=${xname/\</}
    xname=${xname/\>/}
    #xname=${xname/\/}
  done
  # mehrfache "_" reduzieren
  for ((z=0;z<24;z++))
  do
    xname=${xname/__/_}
  done
  # Endung "_" reduzieren
  xname=${xname/%_/}
}

function WarnTrenn { WarnTrennStr='' ; for (( idx=0 ; idx<116 ; idx++ )); do WarnTrennStr="$WarnTrennStr$1" ; done ; printf "$WarnTrennStr" ; }
TRENNER="$(WarnTrenn '=')"
WARNTR="$(WarnTrenn '!')"
